{Copyright Bloodshed Software
 Please send feedback to: webmaster@bloodshed.nu
 http://www.bloodshed.nu/ }

unit Shareware;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,Registry;

type
  TLanguage = (lnPolski, lnEnglish, lnFrench); 
  TShareware = class(TComponent)
  private
  FParentForm: TForm;
  FHowManyDays: Integer;
  FLanguage: TLanguage;
  FIdentifier: string;
    { Dclarations prives }
  protected
    { Dclarations protges }
  public
   constructor Create(AOwner: TComponent); override;
   procedure Execute;
    { Dclarations publiques }
  published
   property HowManyDays: Integer read FHowManyDays write FHowManyDays;
   property Language: TLanguage read FLanguage write FLanguage;
   property Identifier: string read FIdentifier write FIdentifier;
end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Bloodshed', [TShareware]);
end;

constructor TShareware.Create(AOwner: TComponent);
var
   error_text : PChar;
begin
  inherited Create(AOwner);

  if AOwner is TForm then FParentForm := TForm(AOwner) else
    begin
         error_text:='TShareware can only be placed in a form';
         Application.MessageBox(error_text, 'Stop!', mb_OK + mb_IconStop);
         Fail;
    end;
  {Default value of the number of days the user is allowed to use the software}
  FHowManyDays:= 30;
  HowManyDays:= FHowManyDays;
  FLanguage:=lnEnglish;
  Language:=FLanguage;
  FIdentifier:='SecretItem';
  Identifier:=FIdentifier;
end;

procedure TShareware.Execute;
var
  KeyHandle: HKEY;
  Reg_Result: dword;
  Expired: Boolean;
  ExpireDate: TDateTime;
  ValSize: longint;
  message_text: String;
  Reg_Path: String;

begin

  Expired := false;
  { default expire date is the next 30 days }
  ExpireDate := Date + HowManyDays;

  { open registry... }
  { read/write the key from/to "secret" key }
  { in this case, Windows' global registry key! }

  Reg_Path:='Software\Microsoft\windows\CurrentVersion\'+Identifier+'\';
  RegCreateKeyEx(HKEY_CURRENT_CONFIG,
    pchar(Reg_Path),
    0, 'DWORD', REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 
    nil, KeyHandle, @Reg_Result);

  { query "secret" values... }
  ValSize := SizeOf(Expired);
  RegQueryValueEx(KeyHandle,'WinD', nil, nil, @Expired,
    @ValSize);
  ValSize := SizeOf(ExpireDate);
  RegQueryValueEx(KeyHandle,'WinE', nil, nil, @ExpireDate,
    @ValSize);
    
  { is Expire date >= today? }
  if Date >= ExpireDate then
  Expired := True;

  { set back "secret" values }
  { query "secret" values... }
  RegSetValueEx(KeyHandle,'WinD', 0, REG_BINARY, @Expired,  SizeOf(Expired));
  RegSetValueEx(KeyHandle,'WinE', 0, REG_BINARY, @ExpireDate, SizeOf(ExpireDate));

  { don't forget to CLOSE it!!! }
  RegCloseKey(KeyHandle);

  { has this program expired? }
  if Expired then
  begin
    case Language of
         lnPolski : message_text:='Okres testowy tego programu skonczyl sie dnia '+
                  FormatDateTime('dddddd', ExpireDate) + '. ' +
                  'Prosze go zarejestrowac!';
         lnEnglish : message_text:='Sorry. This software has expired on ' +
                  FormatDateTime('dddddd', ExpireDate) + '. ' +
                  'Please register it!';
         lnFrench : message_text:='Dsol. Ce programme  expirer le ' +
                  FormatDateTime('dddddd', ExpireDate) + '. ' +
                  'Enregistrer vous!';
    end;                  
    MessageDlg(message_text, mtError, [mbOK], 0);

    { Bye Bye! }
    Application.Terminate;
  end
  else
  { notify the expire date }
  case Language of
       lnPolski : message_text:='Okres testowy tego programu skonczy sie dnia '+
                FormatDateTime('dddddd', ExpireDate);
       lnEnglish : message_text:='This software will get expired on '+
                FormatDateTime('dddddd', ExpireDate);
       lnFrench : message_text:='Ce programme va s'arrter le '+
                FormatDateTime('dddddd', ExpireDate); 		
  end;                       
  MessageDlg(message_text, mtWarning, [mbOK], 0);

end;

end.
